## ess 17.11

=== Makefile ===
## Top Level Makefile

## Before making changes here, please take a look at Makeconf
include ./Makeconf

ETC_FILES = # etc/SVN-REVISION  etc/ESSR-VERSION

## This is the default target, i.e. 'make' and 'make all' are the same.
all install uninstall: $(ETC_FILES)
	cd etc; $(MAKE) $@
	cd lisp; $(MAKE) $@
	cd doc; $(MAKE) $@

lisp: $(ETC_FILES)
	cd lisp; $(MAKE)

.PHONY: test
test:
	cd test; $(EMACS) --script run-tests

generate-indent-cases:
	cd test; $(EMACS) --script generate-indent-cases

## the rest of the targets are for ESS developer's use only :

# VERSION:
# 	@echo "$(ESSVERSION)" > $@
## Hmm, this is a bit brittle ... but for distribution, there's no problem
## no longer: using git!
# etc/SVN-REVISION etc/SVN-REVISION-tmp: VERSION lisp/*.el doc/*.texi doc/Makefile etc/Makefile lisp/Makefile Makefile Makeconf
# 	(LC_ALL=C TZ=GMT svn info || $(ECHO) "Revision: unknown") 2> /dev/null \
# 	    | sed -n -e '/^Revision/p' -e '/^Last Changed Date/'p \
# 	    | cut -d' ' -f1,2,3,4 > $@-tmp
# 	if [ -s $@-tmp ]; then mv $@-tmp $@ ; elif [ ! -f $@ ]; then echo 'not available' > $@ ; fi

# etc/ESSR-VERSION: etc/ESSR/DESCRIPTION
# 	sed -n '/^Version: */{ s///; s/ *$$//p }' $< > $@


## --- PRE-release ---

# Create .tgz and .zip files only
# GNUTAR=gtar make tarballs
tarballs: $(ESSDIR)
	@echo "**********************************************************"
	@echo "** Making distribution of ESS for (pre)release $(ESSVERSION) from $(ESSDIR)/"
	@echo "** Creating .tgz file **"
	test -f $(ESSDIR).tgz && rm -rf $(ESSDIR).tgz || true
	$(GNUTAR) hcvofz $(ESSDIR).tgz $(ESSDIR)
	@echo "** Creating .zip file **"
	test -f $(ESSDIR).zip && rm -rf $(ESSDIR).zip || true
	zip -r $(ESSDIR).zip $(ESSDIR)
	touch $@

# Create the "release" directory
# run in the foreground so you can accept the certificate
$(ESSDIR): all RPM.spec cleanup-dist
	@echo "**********************************************************"
	@echo "** Making $(ESSDIR) directory of ESS for release $(ESSVERSION),"
	@echo "** (must have setup git / github with cached authentication, prior for security)"
	@echo "**********************************************************"
	@echo "** Exporting Files **"
	git clone git@github.com:emacs-ess/ESS.git $(ESSDIR)-git
	mkdir -p $(ESSDIR)
	(cd $(ESSDIR)-git; $(GNUTAR) cvf - --exclude=.git --exclude=.svn --no-wildcards .) | (cd $(ESSDIR); $(GNUTAR) xf - )
	@echo "** Clean-up docs, Make docs, and Correct Write Permissions **"
	CLEANUP="user-* useR-* Why_* README.*"; ED=$(ESSDIR)/doc; \
	 if [ -d $$ED ] ; then CD=`pwd`; cd $$ED; chmod -R u+w $$CLEANUP; rm -rf $$CLEANUP; \
	 $(MAKE) all cleanaux ; cd $$CD; fi
#	just in case: update from VERSION:
	cd lisp; $(MAKE) ess-custom.el; $(INSTALL) ess-custom.el ../$(ESSDIR)/lisp/; cd ..
	cd lisp; $(MAKE) julia-mode.el; $(INSTALL) julia-mode.el ../$(ESSDIR)/lisp/; cd ..
	$(INSTALL) RPM.spec $(ESSDIR)/
	chmod a-w $(ESSDIR)/lisp/*.el
	chmod u+w $(ESSDIR)/lisp/ess-site.el $(ESSDIR)/Make* $(ESSDIR)/*/Makefile
	touch $(ESSDIR)/etc/.IS.RELEASE
#	# Get (the first 12 hexdigits of) the git version into the release tarball:
	cut -c 1-12 $(ESSDIR)-git/.git/refs/heads/master > $(ESSDIR)/etc/git-ref

dist: VERSION tarballs
	grep -E 'defvar ess-(version|revision)' lisp/ess-custom.el \
	  $(ESSDIR)/lisp/ess-custom.el
	touch $@

.PHONY: cleanup-dist cleanup-rel dist
cleanup-dist:
	@echo "** Cleaning up **"
	rm -f $(ESSDIR)/etc/.IS.RELEASE $(ESSDIR)/etc/git-ref
	(if [ -d $(ESSDIR) ] ; then \
	  chmod -R u+w $(ESSDIR) $(ESSDIR)-git && rm -rf $(ESSDIR) $(ESSDIR)-git; fi)
##  should only be called manually (if at all):
cleanup-rel:
	@rm -f $(ESSDIR)*
##	@rm -f dist lisp/dist $(ESSDIR)*

%.spec: %.spec.in VERSION
	sed 's/@@VERSION@@/$(ESSVERSION)/g' $< > $@


## --- RELEASE section ---

## NB: Typically use  'make -W VERSION ChangeLog' before 'make rel' <<--- MUST
##	since          ~~~~~~~~~~~~~~~~~~~~~~~~~
## 	ChangeLog often ends up newer than VERSION
ChangeLog: VERSION
	@echo "** Adding log-entry to ChangeLog file"
	mv ChangeLog ChangeLog.old
	(echo `date "+%Y-%m-%d "` \
	     " ESS Maintainers <ESS-core@r-project.org>" ; \
	 echo; echo "  * Version $(ESSVERSION) released."; echo; \
	 cat ChangeLog.old ) > ChangeLog
	@rm ChangeLog.old
	git commit -m 'Version $(ESSVERSION)' ChangeLog

tag:
	@echo "** Tagging the release **  1) pull existing;  2) tag  3) push it"
	git pull --tags
	git tag -a -m'release tagging' v$(ESSVERSION)
	@echo '** Pushing the 	v$(ESSVERSION)  upstream ...'
	git push origin v$(ESSVERSION)
	@touch $@

homepage:
	@echo "** Updating ESS Webpage **"
	[ x$$USER = xmaechler ] || (echo 'must be maechler'; exit 1 )
	cd $(ESS_HOMEPAGE); ./update-VERSION $(ESSVERSION)
	@touch $@

upload:
	[ x$$USER = xmaechler ] || (echo 'must be maechler'; exit 1 )
	@echo "** Placing .tgz and .zip files **"
	cp -p $(ESSDIR).tgz $(ESSDIR).zip $(UPLOAD_DIR)
	@echo "** Creating LATEST.IS. file **"
	rm -f $(UPLOAD_DIR)/LATEST.IS.*
	touch $(UPLOAD_DIR)/LATEST.IS.$(ESSDIR)
	touch $@

#==== RELEASE : ====

rel: ChangeLog dist tag homepage upload
	@echo "If all is perfect, eventually call   'make cleanup-rel'"
	touch $@


## TODO (when MM has GPG set up properly): add this to 'rel'
.PHONY: buildrpm
buildrpm: dist
	rpmbuild -ta --sign $(ESSDIR).tgz

builddeb:
	dpkg-buildpackage -uc -us -rfakeroot -tc


## 'clean'     shall remove *exactly* those things that are *not* in version control
## 'distclean' removes also things in VC (svn, when they are remade by "make"):
clean distclean: cleanup-dist
	cd etc; $(MAKE) $@
	cd lisp; $(MAKE) $@
	cd doc; $(MAKE) $@
#	rm -f etc/SVN-REVISION*

=== doc/Makefile ===
### Makefile - for DOCUMENTATION (./doc) of ESS distribution.
###

## Before making changes here, please take a look at Makeconf
include ../Makeconf

# program to convert .texi{nfo} to .html
#MM: use makeinfo (i.e. MAKEHTML from above) which is more
#--  standardized than texi2html which exists in
#MM  at least two widely differing versions (TeX vs GNU):
#MM TEXI2HTML = LANG=C texi2html -verbose -iso
#MM SPLITCHAP = -split_chapter -menu -glossary
##

TEXI2PDF = LANG=C texi2dvi --pdf

# To obtain sorted indices run:	"texindex ess.??".

#### no user servicable parts beyond this point ####

TEXISRC = announc.texi authors.texi bugrept.texi bugs.texi bugs-ms.texi     \
	credits.texi currfeat.texi ess.texi ess-defs.texi getting.texi \
	help-s.texi help-sas.texi inst_svn.texi installation.texi \
	license.texi mailing.texi onewfeat.texi news.texi onews.texi \
	newfeat.texi readme.texi requires.texi stabilty.texi help-bugs.texi \
        help-jags.texi allnews.texi Makefile ../Makeconf ../VERSION

ESSINFONODE1='* ESS: (ess).'
ESSINFONODE2='	        Emacs Speaks Statistics'
ESSINFONODE3='                        (S/S+/R, SAS, BUGS, Stata, XLisp-Stat).'

### Targets --
PDFs = ess.pdf readme.pdf refcard/refcard.pdf
TXTs = ../README ../ANNOUNCE ../NEWS ../ONEWS

all  : info text html pdf
docs : info text html
info : info/ess.info
text : $(TXTs)
html : html/ess.html html/readme.html html/news.html
pdf  : $(PDFs)

ess.pdf : $(TEXISRC); $(TEXI2PDF) ess.texi

readme.pdf : $(TEXISRC); $(TEXI2PDF) readme.texi

cleanaux:
	-@rm -f *.aux *.cp *.cps *.fn *.fns *.ky *.kys *.log *.out \
	        *.pg *.pgs *.tmp *.toc *.tp *.vr *.vrs
## this shall remove *exactly* those things that are *not* in version control:
clean: cleanaux
	-@rm -f $(TXTs) $(PDFs) info/*.info* html/*

## this removes also things in VC (svn, when they are remade by "make"):
distclean : clean
#	-@rm -f $(PDFs)

../README: $(TEXISRC)
	-$(MAKETXT) readme.texi \
	| perl -pe 'last if /^Concept Index/;' > $@
#	| perl -pe 'last if /^Concept Index/; print "For INSTALLATION, see way below.\n\n" if /^\s*ESS grew out of/' \

../ANNOUNCE: $(TEXISRC)
	-$(MAKETXT) announc.texi \
	| perl -pe 'last if /^Concept Index/;' > $@

README.Microsoft : README.Microsoft.texi
	$(MAKETXT) README.Microsoft.texi \
	| perl -pe 'last if /^Concept Index/;' > $@

../NEWS: Makefile ess-defs.texi newfeat.texi news.texi
	-$(MAKETXT) news.texi > $@

../ONEWS: Makefile ess-defs.texi onewfeat.texi onews.texi
	-$(MAKETXT) onews.texi > $@

### File Dependencies

info/ess.info: $(TEXISRC) ../VERSION
	@echo "making Info documentation..."
	-$(MAKEINFO) ess.texi
	mv -f ess.info info/

install: install-info install-other-docs

install-info : info/ess.info
	-$(INSTALLDIR) $(INFODIR)
	$(INSTALL) info/ess.info $(INFODIR)
	test -f $(INFODIR)/dir || $(INSTALL) dir.txt $(INFODIR)/dir
	grep $(ESSINFONODE1) $(INFODIR)/dir || \
	(echo >> $(INFODIR)/dir; echo 'Emacs' >> $(INFODIR)/dir; \
	echo $(ESSINFONODE1) $(ESSINFONODE2) >> $(INFODIR)/dir; \
	echo $(ESSINFONODE3) >> $(INFODIR)/dir)

install-other-docs: pdf html
	-$(INSTALLDIR) $(DOCDIR)
	$(INSTALL) ess.pdf readme.pdf $(DOCDIR)
	$(INSTALL) html/ess.html html/readme.html html/news.html $(DOCDIR)
	$(INSTALL) refcard/refcard.pdf $(DOCDIR)

uninstall :
	-cd $(DOCDIR) && $(UNINSTALL) ess.pdf readme.pdf README ANNOUNCE
	-cd $(DOCDIR) && $(UNINSTALL) ess.html readme.html news.html
	-cd $(DOCDIR) && $(UNINSTALL) refcard.pdf

##  TO DO:  ess_toc.html & readme_toc.html should be merged into index.html
html/ess.html: $(TEXISRC)
	@echo "making HTML documentation..."
	mkdir -p html
	-$(MAKEHTML) html/ess.html ess.texi
#MM	$(TEXI2HTML) $(SPLITCHAP) ess.texi
#MM	test -d ess && cp -p ess/ess_toc.html html/index.html || cp -p ess_toc.html html/index.html
#MM	test -d ess && mv -f ess/*.html html || mv -f *.html html

html/readme.html: $(TEXISRC)
	-$(MAKEHTML) html/readme.html --no-validate readme.texi
		 ##                   ^^^^^^^^^^^^^ (design bug: "FIXME" in ess.texi)
#MM	$(TEXI2HTML) readme.texi
#	mv -f readme.html html

html/news.html: $(TEXISRC)
	mkdir -p html
	-$(MAKEHTML) html/news.html allnews.texi

refcard/refcard.pdf: refcard/refcard.tex
	(cd refcard ; pdflatex refcard)

=== etc/Makefile ===
### Makefile - for scripts and icons (./etc) of ESS distribution.
###

## Before making changes here, please take a look at Makeconf
include ../Makeconf

# In ../Makefile we already construct the  ESSR-VERSION  file :
# ESSR_VERSION = $(shell cat ESSR-VERSION)

#ETCFILES = $(wildcard BACKBUG[S5].BAT backbug[s5] *.S sas-keys.*)
#ETCFILES = ESSR.R ess-developer.R SVN-REVISION *.S sas-keys.* ess-sas-sh-command
ETCFILES_1 = *.S sas-keys.* ess-sas-sh-command *.jl
isRELEASE=$(shell test -f .IS.RELEASE && echo 'yes')
ifeq ($(isRELEASE),yes)
  ETCFILES = .IS.RELEASE git-ref $(ETCFILES_1)
else
  ETCFILES =                     $(ETCFILES_1)
endif

#ICONS = $(wildcard icons/*.xpm)
ICONS = icons/*.xpm

ESSR_UTIL_FILES = ESSR/LOADREMOTE ESSR/VERSION
ESSR_CODE_FILES = ESSR/R/*.R ESSR/R/.*.R
# ESSR_tarball = ESSR_$(ESSR_VERSION).tar.gz

all: #ESSR-VERSION $(ESSR_tarball) library/ESSR

show-etc:
	@echo $(ETCFILES)
	ls -l $(ETCFILES)


## happens "above" as it is need also in ../lisp/ :
# ESSR-VERSION: $(ESSR_FILES)
#	(cd .. ; make etc/ESSR-VERSION)

# $(ESSR_tarball): $(ESSR_FILES)
#	R CMD build ESSR
# library/ESSR: $(ESSR_tarball)
#	R CMD INSTALL -l library ESSR

# rel:  $(ESSR_tarball)
#	[ x$$USER = xmaechler ] || (echo 'must be maechler'; exit 1 )
#	$(INSTALL) $(ESSR_tarball) $(UPLOAD_DIR)/pkgs/src/contrib

install :
	$(INSTALLDIR) $(ETCDIR)/icons
	$(INSTALLDIR) $(ETCDIR)/ESSR/R
	$(INSTALL) $(ETCFILES) $(ETCDIR)
	$(INSTALL) $(ICONS) $(ETCDIR)/icons
	$(INSTALL) $(ESSR_UTIL_FILES) $(ETCDIR)/ESSR
	$(INSTALL) $(ESSR_CODE_FILES) $(ETCDIR)/ESSR/R
	chmod +x $(ETCDIR)/ess-sas-sh-command

uninstall :
	-cd $(ETCDIR) && $(UNINSTALL) $(ETCFILES)
	-cd $(ETCDIR) && $(UNINSTALL) $(ICONS)
	-cd $(ETCDIR) && $(UNINSTALL) $(ESSR_UTIL_FILES)
	-cd $(ETCDIR) && $(UNINSTALL) $(ESSR_CODE_FILES)



## 'clean'     shall remove *exactly* those things that are *not* in version control
clean:
	rm -rf SVN-REVISION
## 'distclean' removes also things in VC (svn, when they are remade by "make"):
# distclean: clean
#	rm -rf ESSR_*.tar.gz

=== lisp/Makefile ===
### Makefile - for compiled e-lisp of ESS distribution.
###

## Before making changes here, please take a look at Makeconf
include ../Makeconf

## For noweb extraction of code and documentation.

NOTANGLE=notangle -L
#NOTANGLE=notangle for no indexing.
NOWEAVE=noweave

## SUFFIXES are in ../Makeconf :
.nw.html: ;     $(NOWEAVE) -filter l2h -index -html $*.nw > $*.html
.nw.tex: ;      $(NOWEAVE) -index -delay $*.nw | cpif $*.tex
.nw.el:  ;      $(NOTANGLE) -R$*.el | cpif $*.el
##.nw.c:  ;       $(NOTANGLE) -R$*.c | cpif $*.c
##.nw.h:  ;       $(NOTANGLE) -R$*.h | cpif $*.h
.tex.dvi: ;     latex '\scrollmode \input '"$*"; while grep -s 'Rerun to get cross-references right' $*.log; do latex '\scrollmode \input '"$*"; done

# have to preload the files that contain macro definitions or the
# byte compiler will compile everything that references them
# incorrectly.  also preload a file that sets byte compiler options.
PRELOADS = -l ./ess-comp.el


## files that contain key macro definitions.  almost everything
## depends on them because the byte-compiler inlines macro expansions.
## everything also depends on the byte compiler options file since
## this might do odd things like turn off certain compiler
## optimizations.  When these change, RECOMPILE.
CORE = ess.elc ess-site.elc

### Everything but ess-debug.el, ess-install.el
###		  ess-send.el , ess-send2.el
### DEPRECATED:  essl-bug.el
##
ELC = $(CORE) ess-comp.elc ess-custom.elc \
	ess-dde.elc ess-compat.elc ess-font-lock.elc \
	ess-help.elc ess-inf.elc ess-mode.elc \
	ess-mouse.elc mouseme.elc \
	ess-swv.elc ess-toolbar.elc \
	ess-trns.elc ess-utils.elc \
	essd-els.elc ess-gretl.elc \
	ess-lsp-l.elc ess-xls-d.elc ess-vst-d.elc ess-arc-d.elc \
	ess-sas-l.elc ess-sas-d.elc ess-sas-a.elc \
	ess-stata-lang.elc ess-stata-mode.elc make-regexp.elc \
	ess-omg-l.elc ess-omg-d.elc \
	ess-bugs-l.elc ess-bugs-d.elc ess-jags-d.elc \
	ess-noweb.elc ess-noweb-mode.elc ess-noweb-font-lock-mode.elc \
	ess-eldoc.elc ess-roxy.elc ess-rutils.elc ess-r-completion.elc \
	ess-s-lang.elc ess-s3-d.elc ess-s4-d.elc \
	ess-sp3-d.elc ess-sp4-d.elc ess-sp5-d.elc ess-sp6-d.elc \
	ess-rdired.elc ess-r-args.elc ess-r-syntax.elc ess-r-mode.elc ess-rd.elc \
	ess-r-package.elc ess-tracebug.elc ess-julia.elc\
	julia-mode.elc\
	ess-generics.elc ess-r-gui.elc\
	ess-sp6w-d.elc msdos.elc
##      ^^^^^^^^^^^^^^^^^^^^^^^ Windows only (but be platform-oblivious)
## julia-mode.el : really from the julia sources -- but want in tarball!


# ESSR_VER =`cat ../etc/ESSR-VERSION`
##ESSR_VER = $(shell cat ../etc/ESSR-VERSION)

### Targets

all: $(ELC) ess-custom.el

.PHONY: dist
dist: all julia-mode.el
##	@touch dist
## svn committing happens in ../Makefile

install: dist
	-$(INSTALLDIR) $(LISPDIR)
	$(INSTALL) ChangeLog *.elc $(LISPDIR)
	-export J; for I in *.elc; do J=$$I; $(INSTALL) `basename $$J .elc`.el $(LISPDIR); done
	if [ -f /etc/debian_version -a -n "$(SITELISP)" -a ! -f "$(SITELISP)/ess-site.el" ] ; \
	then \
		ln -s $(LISPDIR)/ess-site.el $(SITELISP)/ess-site.el ; \
	fi;
#	test "$(LISPDIR)" = "." || $(INSTALL) *.elc $(LISPDIR)

uninstall:
	-cd $(LISPDIR) && $(UNINSTALL) ChangeLog *.elc *.el
	if [ -n "$(SITELISP)" -a -h "$(SITELISP)/ess-site.el" ] ; \
	then \
		cd $(SITELISP) && $(UNINSTALL) ess-site.el ; \
	fi;
clean:
	rm -f $(ELC)

distclean: clean
# and potentially more

### Targets below here are only for developers - and these must have perl

### Replace Version numbers (as in ../doc/Makefile !):
## "../VERSION" if that changes, *definitely* need to update ess-custom.el
ess-custom.el: ../VERSION
	EV='$(ESSVERSION)'; perl -pi -e "s/\".*\"/\"$$EV\"/ if /ess-version/" $@

# ess-r-mode.el: ../etc/ESSR-VERSION
# 	sed -i -e '/let.*ESSR-version/s/"[-.0-9]*"/"$(ESSR_VER)"/' $@

## Should happen before building ESS; definitely *NOT* after unpacking tarball :
julia-mode.el:
	test -f ../etc/.IS.RELEASE || $(DOWNLOAD) \
 https://raw.githubusercontent.com/JuliaLang/julia-emacs/master/julia-mode.el > $@

### File Dependencies

.el.elc:
	$(EMACSBATCH) $(PRELOADS) -f batch-byte-compile $<


ess-custom.elc: ess-custom.el ess-comp.el
	$(EMACSBATCH) $(PRELOADS) -f batch-byte-compile ess-custom.el

ess.elc: ess.el ess-comp.el ess-custom.elc
	$(EMACSBATCH) $(PRELOADS) -l ess-custom.elc -f batch-byte-compile ess.el

ess-site.elc: ess-site.el ess.elc

ess-inf.elc: ess-inf.el ess-comp.el $(CORE)
# 	@echo " "
# 	@echo "For the next compile, please disregard the messages"
# 	@echo " ** the function set-keymap-parent is not known to be defined."
# 	@echo " ** assignment to free variable comint-last-input-end"
# 	@echo "from the byte compiler if they occur. It is completely normal."
	$(EMACSBATCH) $(PRELOADS) -f batch-byte-compile ess-inf.el


ess-mode.elc: ess-mode.el ess-comp.el $(CORE)
	$(EMACSBATCH) $(PRELOADS) -f batch-byte-compile ess-mode.el

ess-trns.elc: ess-trns.el ess-comp.el $(CORE)
	$(EMACSBATCH) $(PRELOADS) -f batch-byte-compile ess-trns.el

ess-help.elc: ess-help.el $(CORE)

## S languages

ess-s-lang.elc : ess-s-lang.el ess.elc

ess-sas-d.elc : ess-sas-d.el ess.elc

ess-s3-d.elc : ess-s3-d.el ess-s-lang.elc ess.elc

ess-sp3-d.elc : ess-sp3-d.el ess-s-lang.elc ess.elc

ess-s4-d.elc : ess-s4-d.el ess-s-lang.elc ess.elc

ess-r-mode.elc : ess-r-mode.el ess-s-lang.elc ess.elc

ess-swv.elc: ess-swv.el ess-noweb.elc

## Lisp Languages

ess-lsp-l.elc : ess-lsp-l.el ess.elc

ess-xls-d.elc : ess-xls-d.el ess-lsp-l.elc ess.elc

ess-vst-d.elc : ess-vst-d.el ess-lsp-l.elc ess.elc

## SAS

ess-sas-l.elc : ess-sas-l.el ess-sas-a.el ess.elc

ess-sas-d.elc : ess-sas-d.el ess-sas-l.elc ess.elc

## Stata

ess-stata-lang.elc : ess-stata-lang.el ess.elc

ess-stata-mode.elc : ess-stata-mode.el ess.elc

## BUGS

ess-bugs-l.elc : ess-bugs-l.el ess-compat.elc

ess-bugs-d.elc : ess-bugs-d.el ess-bugs-l.elc

## JAGS

ess-jags-d.elc : ess-jags-d.el ess-bugs-l.elc ess-utils.elc ess-inf.elc

## GRETL

ess-gretl.elc : ess-gretl.el

ess-r-gui.elc : ess-r-gui.el ess-dde.elc

# Ignore this.
#(defun S-insert-make-rule (file)
#  (interactive "sFile:")
#  (insert (format "%s.elc:  %s.el $(CORE)\n\t@echo compiling %s.el...\n\t@$(EMACSBATCH) $(PRELOADS) -f batch-byte-compile %s.el" file file file file)))

=== test/Makefile ===
EMACS=/usr/bin/emacs

all:
	${EMACS} -Q --script run-tests

inf:
	${EMACS} -Q --script run-tests --inf

r:
	${EMACS} -Q --script run-tests --rstats

r-indent:
	${EMACS} -Q --script run-tests --rstats-indent


cases: indent-cases literate-cases

indent-cases:
	${EMACS} -Q --script generate-indent-cases

literate-cases:
	${EMACS} -Q --script generate-literate-cases

=== test/dummy-pkg/DESCRIPTION ===
Package: foo
Title: title
License: GPL-2
Description: Package description.
Author: author <author@email.com>
Maintainer: maintainer <maintainer@email.com>
Version: 0.1

=== debian/changelog ===
ess (17.11-3xenial0) xenial; urgency=medium

  * Compilation for Ubuntu 16.04.4 LTS
  * debian/control, revert to a version of emacsen-common that is
    available

 -- Michael Rutter <marutter@gmail.com>  Sun, 19 Aug 2018 18:47:39 +0000

ess (17.11-3) unstable; urgency=medium

  * debian/emacsen-install: Allow 'emacs' to accommodate Emacs packaging in
    unstable; also no longer link el files back 	(Closes: #906517)

 -- Dirk Eddelbuettel <edd@debian.org>  Sat, 18 Aug 2018 08:52:36 -0500

ess (17.11-2) unstable; urgency=medium

  * lisp/ess-utils.el: Synced with updated upstream per issue #465
  * lisp/ess-site.el: Ditto				(Closes: #882042)

 -- Dirk Eddelbuettel <edd@debian.org>  Mon, 20 Nov 2017 17:08:32 -0600

ess (17.11-1) unstable; urgency=medium

  * New upstream version released today

  * debian/emacsen-install: Improvement suggested in #850041 install
  * debian/control: Increased Standards-Version: to current version
 
  * debian/control: Increased Standards-Version: to current version
  * debian/compat: Increased to 9

 -- Dirk Eddelbuettel <edd@debian.org>  Mon, 13 Nov 2017 20:29:44 -0600

ess (16.10-1) unstable; urgency=medium

  * New upstream version released today

 -- Dirk Eddelbuettel <edd@debian.org>  Sat, 22 Oct 2016 11:04:13 -0500

ess (16.04-2) unstable; urgency=medium

  * debian/emacsen-install: Skip installation for emacs23
  * debian/control: Note requirement for emacs24 or later
  
  * debian/control: Increased Standards-Version: to current version

 -- Dirk Eddelbuettel <edd@debian.org>  Sun, 22 May 2016 15:30:40 -0500

ess (16.04-1) unstable; urgency=medium

  * New upstream version released today

 -- Dirk Eddelbuettel <edd@debian.org>  Sat, 07 May 2016 11:46:33 -0500

ess (15.09.2-3) unstable; urgency=low

  * debian/control: Add Build-Depends on texlive-fonts-recommended

 -- Dirk Eddelbuettel <edd@debian.org>  Sun, 06 Mar 2016 09:39:09 -0600

ess (15.09.2-2) unstable; urgency=low

  * doc/texinfo.tex: Temporarily adding copy from texinfo 6.0 to avoid
    breakage with the version included with texinfo 6.1	(Closes: #815734)

 -- Dirk Eddelbuettel <edd@debian.org>  Thu, 03 Mar 2016 07:43:01 -0600

ess (15.09.2-1) unstable; urgency=low

  * New upstream version released today

 -- Dirk Eddelbuettel <edd@debian.org>  Fri, 11 Dec 2015 06:17:51 -0600

ess (15.09.1-1) unstable; urgency=low

  * New upstream version released today

  * debian/emacsen-install: Call gzip with '-f' to ensure in-place upgrades
  							(Closes: #802953)

  * debian/control: Shift Maintainer: address from ess-debian list to me,
    remove now-redundant Uploaders: field		(Closes: #803003)

 -- Dirk Eddelbuettel <edd@debian.org>  Mon, 26 Oct 2015 19:22:28 -0500

ess (15.09-1) unstable; urgency=low

  * New upstream version 

 -- Dirk Eddelbuettel <edd@debian.org>  Sat, 26 Sep 2015 21:20:07 -0500

ess (15.03-1-2) unstable; urgency=low

  * debian/emacsen-compat: Added, with value of zero
  
  * debian/emacsen-install: Refreshed
  
  * debian/control: Depends: emacsen-common (>= 2.0.8) per Emacsen Policy

 -- Dirk Eddelbuettel <edd@debian.org>  Mon, 04 May 2015 20:29:39 -0500

ess (15.03-1-1) unstable; urgency=low

  * New upstream version released today 

 -- Dirk Eddelbuettel <edd@debian.org>  Thu, 23 Apr 2015 12:38:30 -0500

ess (15.03-1) unstable; urgency=low

  * New upstream version released today 
  
  * debian/control: Change Depends: on r-base-core to Recommends:
							  (Closes: #767043)
  * debian/control: Add julia to Suggests:

  * debian/control: Increased Standards-Version: to current version

 -- Dirk Eddelbuettel <edd@debian.org>  Wed, 01 Apr 2015 05:31:31 -0500

ess (14.09-1) unstable; urgency=low

  * New upstream version released today 

 -- Dirk Eddelbuettel <edd@debian.org>  Sat, 13 Sep 2014 09:03:04 -0500

ess (13.09-1-1) unstable; urgency=low

  * New upstream version released today 

  * debian/control: Increased Standards-Version: to current version

 -- Dirk Eddelbuettel <edd@debian.org>  Sat, 07 Dec 2013 13:26:27 -0600

ess (13.09-1) unstable; urgency=low

  * New upstream version released today 

  * debian/control: Increased Standards-Version: to current version

  * debian/control: Added Build-Depends: on autotools-dev to always use
    current autotools file
  
 -- Dirk Eddelbuettel <edd@debian.org>  Fri, 27 Sep 2013 18:41:32 -0500

ess (13.05-3) unstable; urgency=low

  * debian/emacsen-install (PACKAGE): Do not attempt installation for
    either emacs22 or xemacs21 which are no longer supported upstream
					(Closes: #708930, #710438)
  
 -- Dirk Eddelbuettel <edd@debian.org>  Sat, 01 Jun 2013 13:35:06 -0500

ess (13.05-2) unstable; urgency=low

  * lisp/ess-stan-d.el: Comment-out the file which should not have been in
    the release.

 -- Dirk Eddelbuettel <edd@debian.org>  Fri, 17 May 2013 13:54:28 -0500

ess (13.05-1) unstable; urgency=low

  * New upstream version released today 

 -- Dirk Eddelbuettel <edd@debian.org>  Wed, 15 May 2013 06:31:40 -0500

ess (12.09-2-1) unstable; urgency=low

  * New upstream version released today

 -- Dirk Eddelbuettel <edd@debian.org>  Sat, 12 Jan 2013 15:51:47 -0600

ess (12.09-1-1) unstable; urgency=low

  * New upstream version released twelve hours ago

  * debian/control: Mention Julia in Description:	(Closes: #692468)

 -- Dirk Eddelbuettel <edd@debian.org>  Sat, 22 Dec 2012 00:56:45 -0600

ess (12.09-1) unstable; urgency=low

  * New upstream version released today

 -- Dirk Eddelbuettel <edd@debian.org>  Mon, 24 Sep 2012 14:32:49 -0500

ess (12.04-4-1) unstable; urgency=low

  * New upstream patch version released today

 -- Dirk Eddelbuettel <edd@debian.org>  Thu, 07 Jun 2012 11:52:04 -0500

ess (12.04-3-1) unstable; urgency=low

  * New upstream patch version released today

 -- Dirk Eddelbuettel <edd@debian.org>  Fri, 01 Jun 2012 08:53:38 -0500

ess (12.04-2-1) unstable; urgency=low

  * New upstream patch version released today



=== debian/control ===
Source: ess
Section: gnu-r
Priority: optional
Maintainer: Dirk Eddelbuettel <edd@debian.org>
Standards-Version: 4.1.1
Build-Depends: debhelper (>= 7.0.0)
Build-Depends-Indep: texlive-base, texlive-latex-base, texlive-latex-recommended, texlive-latex-extra, texlive-generic-recommended, texlive-extra-utils, texlive-fonts-recommended, texinfo, autotools-dev
Homepage: http://ess.r-project.org

Package: ess
Architecture: all
Depends: ${misc:Depends}, emacsen-common, dpkg (>= 1.15.4) | install-info
Recommends: r-base-core
Conflicts: dhelp (<= 0.3.12)
Suggests: xlispstat, pspp, jags, julia
Description: Emacs mode for statistical programming and data analysis
 ESS ("Emacs Speaks Statistics") is a GNU Emacs and XEmacs mode for 
 interactive statistical programming and data analysis. Languages 
 supported are the S family (S 3/4, S-PLUS 3/4/5/6/7, and R), SAS, 
 XLispStat, Stata, BUGS and Julia.
 .
 ESS grew out of the desire for bug fixes and extensions to S-mode and
 SAS-mode as well as a consistent union of their features in one
 package.
 .
 As of versions 16.04 or later, Emacs version 24 or later is required.

## ess 18.10

=== Makefile ===
--- 
+++ 
@@ -3,39 +3,48 @@
 ## Before making changes here, please take a look at Makeconf
 include ./Makeconf
 
-ETC_FILES = # etc/SVN-REVISION  etc/ESSR-VERSION
-
-## This is the default target, i.e. 'make' and 'make all' are the same.
+## 'all' is the default target, i.e. 'make' and 'make all' are the same.
+.PHONY: all install uninstall
 all install uninstall: $(ETC_FILES)
-	cd etc; $(MAKE) $@
 	cd lisp; $(MAKE) $@
 	cd doc; $(MAKE) $@
+	cd etc; $(MAKE) $@
 
-lisp: $(ETC_FILES)
+.PHONY: version
+version:
+	@echo "********************* VERSIONS **************************"
+	@echo $(shell $(EMACS) --version | sed -n 1p)
+	@echo ESS $(ESSVERSION)
+	@echo "*********************************************************"
+
+.PHONY: lisp
+lisp: version
 	cd lisp; $(MAKE)
 
+.PHONY: doc
+doc: version
+	cd doc; $(MAKE)
+
+.PHONY: etc
+etc: version
+	cd etc; $(MAKE)
+
 .PHONY: test
-test:
+test: version
 	cd test; $(EMACS) --script run-tests
 
 generate-indent-cases:
 	cd test; $(EMACS) --script generate-indent-cases
 
+.PHONY: julia
+julia:
+	cd lisp; $(MAKE) julia-mode.el
+
+.PHONY: autoloads
+autoloads:
+	cd lisp; $(MAKE) ess-autoloads.el
+
 ## the rest of the targets are for ESS developer's use only :
-
-# VERSION:
-# 	@echo "$(ESSVERSION)" > $@
-## Hmm, this is a bit brittle ... but for distribution, there's no problem
-## no longer: using git!
-# etc/SVN-REVISION etc/SVN-REVISION-tmp: VERSION lisp/*.el doc/*.texi doc/Makefile etc/Makefile lisp/Makefile Makefile Makeconf
-# 	(LC_ALL=C TZ=GMT svn info || $(ECHO) "Revision: unknown") 2> /dev/null \
-# 	    | sed -n -e '/^Revision/p' -e '/^Last Changed Date/'p \
-# 	    | cut -d' ' -f1,2,3,4 > $@-tmp
-# 	if [ -s $@-tmp ]; then mv $@-tmp $@ ; elif [ ! -f $@ ]; then echo 'not available' > $@ ; fi
-
-# etc/ESSR-VERSION: etc/ESSR/DESCRIPTION
-# 	sed -n '/^Version: */{ s///; s/ *$$//p }' $< > $@
-
 
 ## --- PRE-release ---
 
@@ -45,16 +54,27 @@
 	@echo "**********************************************************"
 	@echo "** Making distribution of ESS for (pre)release $(ESSVERSION) from $(ESSDIR)/"
 	@echo "** Creating .tgz file **"
+	cd doc/ ; $(MAKE) pdf
+	cd doc/ ; $(MAKE) html
 	test -f $(ESSDIR).tgz && rm -rf $(ESSDIR).tgz || true
 	$(GNUTAR) hcvofz $(ESSDIR).tgz $(ESSDIR)
+	@echo "Signing tgz file"
+	$(GPG) -ba -o $(ESSDIR).tgz.sig $(ESSDIR).tgz
 	@echo "** Creating .zip file **"
 	test -f $(ESSDIR).zip && rm -rf $(ESSDIR).zip || true
 	zip -r $(ESSDIR).zip $(ESSDIR)
+	@echo "Signing zip file"
+	$(GPG) -ba -o $(ESSDIR).zip.sig $(ESSDIR).zip
 	touch $@
 
 # Create the "release" directory
 # run in the foreground so you can accept the certificate
-$(ESSDIR): all RPM.spec cleanup-dist
+# NB 'all', 'cleanup-dist' must not be targets: otherwise, e.g.
+#    'make tarball' re-builds the tarballs always!
+$(ESSDIR): RPM.spec
+	$(MAKE) all
+#	remove previous ESSDIR, etc:
+	$(MAKE) cleanup-dist
 	@echo "**********************************************************"
 	@echo "** Making $(ESSDIR) directory of ESS for release $(ESSVERSION),"
 	@echo "** (must have setup git / github with cached authentication, prior for security)"
@@ -79,19 +99,19 @@
 
 dist: VERSION tarballs
 	grep -E 'defvar ess-(version|revision)' lisp/ess-custom.el \
-	  $(ESSDIR)/lisp/ess-custom.el
-	touch $@
+	  $(ESSDIR)/lisp/ess-custom.el > $@
 
-.PHONY: cleanup-dist cleanup-rel dist
+.PHONY: cleanup-dist cleanup-rel
 cleanup-dist:
 	@echo "** Cleaning up **"
 	rm -f $(ESSDIR)/etc/.IS.RELEASE $(ESSDIR)/etc/git-ref
 	(if [ -d $(ESSDIR) ] ; then \
 	  chmod -R u+w $(ESSDIR) $(ESSDIR)-git && rm -rf $(ESSDIR) $(ESSDIR)-git; fi)
+
 ##  should only be called manually (if at all):
 cleanup-rel:
-	@rm -f $(ESSDIR)*
-##	@rm -f dist lisp/dist $(ESSDIR)*
+#	@rm -rf $(ESSDIR)*
+	@rm -f tarballs dist tag homepage upload rel
 
 %.spec: %.spec.in VERSION
 	sed 's/@@VERSION@@/$(ESSVERSION)/g' $< > $@
@@ -112,13 +132,20 @@
 	@rm ChangeLog.old
 	git commit -m 'Version $(ESSVERSION)' ChangeLog
 
+
 tag:
 	@echo "** Tagging the release **  1) pull existing;  2) tag  3) push it"
 	git pull --tags
-	git tag -a -m'release tagging' v$(ESSVERSION)
+	@echo "Creating tag (no signing, as that fails for MM)"
+	git tag -m'release tagging' v$(ESSVERSION)
 	@echo '** Pushing the 	v$(ESSVERSION)  upstream ...'
 	git push origin v$(ESSVERSION)
 	@touch $@
+
+# signing fails for MM (gpg2 / gpg ??) --> use a non-signed tag above
+
+# @echo "Creating tag and signing using $(GPG)"
+# git tag -s -m'release tagging' v$(ESSVERSION)
 
 homepage:
 	@echo "** Updating ESS Webpage **"
@@ -128,8 +155,8 @@
 
 upload:
 	[ x$$USER = xmaechler ] || (echo 'must be maechler'; exit 1 )
-	@echo "** Placing .tgz and .zip files **"
-	cp -p $(ESSDIR).tgz $(ESSDIR).zip $(UPLOAD_DIR)
+	@echo "** Placing .tgz and .zip files and their .sig's **"
+	cp -p $(ESSDIR).tgz $(ESSDIR).tgz.sig $(ESSDIR).zip $(ESSDIR).zip.sig $(UPLOAD_DIR)
 	@echo "** Creating LATEST.IS. file **"
 	rm -f $(UPLOAD_DIR)/LATEST.IS.*
 	touch $(UPLOAD_DIR)/LATEST.IS.$(ESSDIR)
@@ -142,7 +169,8 @@
 	touch $@
 
 
-## TODO (when MM has GPG set up properly): add this to 'rel'
+## NB: The rpm (SuSE, RH, FC) and debian packages are built *and* signed
+##     by the down stream maintainers:
 .PHONY: buildrpm
 buildrpm: dist
 	rpmbuild -ta --sign $(ESSDIR).tgz
@@ -150,11 +178,10 @@
 builddeb:
 	dpkg-buildpackage -uc -us -rfakeroot -tc
 
-
+## Old Note (clean and distclean are now the same):
 ## 'clean'     shall remove *exactly* those things that are *not* in version control
 ## 'distclean' removes also things in VC (svn, when they are remade by "make"):
 clean distclean: cleanup-dist
 	cd etc; $(MAKE) $@
 	cd lisp; $(MAKE) $@
 	cd doc; $(MAKE) $@
-#	rm -f etc/SVN-REVISION*

=== lisp/Makefile ===
### Makefile - for compiled e-lisp of ESS distribution.
###

## Before making changes here, please take a look at Makeconf
include ../Makeconf

## For noweb extraction of code and documentation.

NOTANGLE=notangle -L
#NOTANGLE=notangle for no indexing.
NOWEAVE=noweave

## SUFFIXES are in ../Makeconf :
.nw.html: ;     $(NOWEAVE) -filter l2h -index -html $*.nw > $*.html
.nw.tex: ;      $(NOWEAVE) -index -delay $*.nw | cpif $*.tex
.nw.el:  ;      $(NOTANGLE) -R$*.el | cpif $*.el
##.nw.c:  ;       $(NOTANGLE) -R$*.c | cpif $*.c
##.nw.h:  ;       $(NOTANGLE) -R$*.h | cpif $*.h
.tex.dvi: ;     latex '\scrollmode \input '"$*"; while grep -s 'Rerun to get cross-references right' $*.log; do latex '\scrollmode \input '"$*"; done

# Have to preload the files that contain macro definitions or the byte compiler
# will compile everything that references them incorrectly. Also preload a file
# that sets byte compiler options.
COMPILE = $(EMACSBATCH) --directory . -f batch-byte-compile

ELS = $(wildcard *.el)
ELS := $(filter-out ess-autoloads.el, $(ELS))
ELC = $(ELS:.el=.elc)

# ESSR_VER =`cat ../etc/ESSR-VERSION`
##ESSR_VER = $(shell cat ../etc/ESSR-VERSION)

### Targets

all: julia-mode.el $(ELC) ess-custom.el ess-autoloads.el

.PHONY: dist
dist: all

install: dist
	-$(INSTALLDIR) $(LISPDIR)
	$(INSTALL) *.elc $(LISPDIR)
	$(INSTALL) obsolete/*.elc $(LISPDIR)
	-export J; for I in *.elc; do J=$$I; $(INSTALL) `basename $$J .elc`.el $(LISPDIR); done
	if [ -f /etc/debian_version -a -n "$(SITELISP)" -a ! -f "$(SITELISP)/ess-site.el" ] ; \
	then \
		ln -s $(LISPDIR)/ess-site.el $(SITELISP)/ess-site.el ; \
	fi;
#	test "$(LISPDIR)" = "." || $(INSTALL) *.elc $(LISPDIR)

uninstall:
	-cd $(LISPDIR) && $(UNINSTALL) *.elc *.el
	if [ -n "$(SITELISP)" -a -h "$(SITELISP)/ess-site.el" ] ; \
	then \
		cd $(SITELISP) && $(UNINSTALL) ess-site.el ; \
	fi;

clean:
	rm -f $(ELC)
	rm -f ess-autoloads.el

distclean: clean
# and potentially more

### Targets below here are only for developers - and these must have perl

### Replace Version numbers (as in ../doc/Makefile !):
## "../VERSION" if that changes, *definitely* need to update ess-custom.el
ess-custom.el: ../VERSION
	EV='$(ESSVERSION)'; perl -pi -e "s/\".*\"/\"$$EV\"/ if /ess-version/" $@

# ess-r-mode.el: ../etc/ESSR-VERSION
# 	sed -i -e '/let.*ESSR-version/s/"[-.0-9]*"/"$(ESSR_VER)"/' $@

## Should happen before building ESS; definitely *NOT* after unpacking tarball :
julia-mode.el:
	test -f ../etc/.IS.RELEASE || $(DOWNLOAD) \
	https://raw.githubusercontent.com/JuliaEditorSupport/julia-emacs/master/julia-mode.el > $@

ess-julia.elc: julia-mode.elc

ess-autoloads.el:
	@printf	"\nGenerating $@\n"
	$(EMACSBATCH) --eval "(progn\
	(setq make-backup-files nil)\
	(setq generated-autoload-file (expand-file-name \"$@\"))\
	(setq find-file-visit-truename t)\
	(update-directory-autoloads default-directory))"

### File Dependencies

.el.elc:
	$(COMPILE) $<

ess-custom.elc: ess-custom.el
	$(COMPILE) ess-custom.el

ess.elc: ess.el ess-custom.elc
	$(COMPILE) ess.el

ess-site.elc: ess-site.el ess.elc

ess-inf.elc: ess-inf.el $(CORE)
# 	@echo " "
# 	@echo "For the next compile, please disregard the messages"
# 	@echo " ** the function set-keymap-parent is not known to be defined."
# 	@echo " ** assignment to free variable comint-last-input-end"
# 	@echo "from the byte compiler if they occur. It is completely normal."
	$(COMPILE) ess-inf.el

ess-trns.elc: ess-trns.el $(CORE)
	$(COMPILE) ess-trns.el

ess-help.elc: ess-help.el $(CORE)

## S languages

ess-s-lang.elc : ess-s-lang.el ess.elc

ess-sas-d.elc : ess-sas-d.el ess.elc

ess-s3-d.elc : ess-s3-d.el ess-s-lang.elc ess.elc

ess-sp3-d.elc : ess-sp3-d.el ess-s-lang.elc ess.elc

ess-s4-d.elc : ess-s4-d.el ess-s-lang.elc ess.elc

ess-r-mode.elc : ess-r-mode.el ess-s-lang.elc ess.elc

ess-swv.elc: ess-swv.el ess-noweb.elc

## Lisp Languages

ess-lsp-l.elc : ess-lsp-l.el ess.elc

ess-xls-d.elc : ess-xls-d.el ess-lsp-l.elc ess.elc

ess-vst-d.elc : ess-vst-d.el ess-lsp-l.elc ess.elc

## SAS

ess-sas-l.elc : ess-sas-l.el ess-sas-a.el ess.elc

ess-sas-d.elc : ess-sas-d.el ess-sas-l.elc ess.elc

## Stata

ess-stata-lang.elc : ess-stata-lang.el ess.elc

ess-stata-mode.elc : ess-stata-mode.el ess.elc

## BUGS

ess-bugs-l.elc : ess-bugs-l.el

ess-bugs-d.elc : ess-bugs-d.el ess-bugs-l.elc

## JAGS

ess-jags-d.elc : ess-jags-d.el ess-bugs-l.elc ess-utils.elc ess-inf.elc

## GRETL

ess-gretl.elc : ess-gretl.el

ess-r-gui.elc : ess-r-gui.el ess-dde.elc


# Ignore this.
#(defun S-insert-make-rule (file)
#  (interactive "sFile:")
#  (insert (format "%s.elc:  %s.el $(CORE)\n\t@echo compiling %s.el...\n\t@$(COMPILE) %s.el" file file file file)))

# Use this to print an envvar for debugging purposes.
# Example: make print-EMACS
print-%: ; @echo $* = $($*)

=== debian/changelog ===
ess (18.10-1xenial0) xenial; urgency=medium

  * Compilation for Ubuntu 16.04.4 LTS
  * debian/control, revert to a version of emacsen-common that is
    available

 -- Michael Rutter <marutter@gmail.com>  Sun, 21 Oct 2018 14:40:33 +0000

ess (18.10-1) unstable; urgency=medium

  * New upstream version released today

 -- Dirk Eddelbuettel <edd@debian.org>  Sat, 20 Oct 2018 15:53:28 -0500

ess (17.11-5) unstable; urgency=medium

  * Rebuilding for Debian unstable			(Closes: #907165)

  * debian/README.Debian: Added

 -- Dirk Eddelbuettel <edd@debian.org>  Fri, 24 Aug 2018 06:57:53 -0500

ess (17.11-4) experimental; urgency=medium

  [David Bremner]
  * experimental conversion to dh_elpa

  [Dirk Eddelbuettel]
  * Applied David's patch, adding transition package ess, tweaks
  * Many thanks to David for the help in converting to an elpa package

 -- Dirk Eddelbuettel <edd@debian.org>  Sat, 18 Aug 2018 16:02:02 -0500

=== debian/rules ===
#!/usr/bin/make -f
#-*- makefile -*-
# Made with the aid of dh_make, by Craig Small
# Sample debian/rules that uses debhelper. GNU copyright 1997 by Joey Hess.
# Some lines taken from debmake, by Christoph Lameter.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# This is the debhelper compatability version to use.
#export DH_COMPAT=1

## edd 16 May 2008  trivial 'orig.tar.gz' creator
##                  technically, this could be a native Debian package as
##                  the debian/ is in upstream SVN but it is easier to have
##                  another degree of freedom for Debian revisions
##                  if we used just the svn rev: version := $(shell svnversion)
## edd 04 Oct 2008  use changelog entry instead
version := $(shell head -1 debian/changelog | perl -nle 'm/\((\S+)-\d\)/ && print $$1')

showversion:
	@echo Version is ${version}

tarball:
	(cd .. && \
		tar czf tarballs/ess_${version}.orig.tar.gz ess \
			--exclude=.svn \
			--exclude=.git \
			--exclude=debian )

build: build-arch build-indep
build-arch: build-stamp
build-indep: build-stamp
build-stamp:
	dh_testdir

	chmod -R u+w *

#	$(MAKE) -C doc ess.dvi
#	$(MAKE) -C doc readme.dvi
#	$(MAKE) -C doc
	(cd doc; $(MAKE) all; $(MAKE) info; $(MAKE) pdf; $(MAKE) html; cd -)

	touch build-stamp

clean:
	dh_testdir
	dh_testroot

	chmod -R u+w *

	rm -f build-stamp install-stamp doc/*.info*

	[ ! -f Makefile ] || $(MAKE) clean

	rm -f doc/*.dvi #README ANNOUNCE doc/html/readme.html doc/html/ess.html
	rm -f doc/refcard/refcard.log doc/refcard/refcard.aux

	rm -f lisp/ess-pkg.el
	dh_clean

install: install-stamp
install-stamp: build-stamp
	dh_testdir
	dh_testroot
	dh_prep 
	dh_installdirs

#	cd doc ; $(MAKE) install PREFIX=`pwd`/debian/ess
#	! [ -e debian/ess/usr/share/emacs/site-lisp/ess/ess-site.el ] || \
#	    chmod u+w debian/ess/usr/share/emacs/site-lisp/ess/ess-site.el
	sed -i -e 's,(defvar ess-etc-directory nil,(defvar ess-etc-directory "/usr/share/ess/etc/",1'\
	    -e 's,(while (and (listp ess-etc,(while (and (not ess-etc-directory) (listp ess-etc,1' \
		lisp/ess-site.el
	cp -vax debian/ess-pkg.el lisp/
	dh_elpa
#	mkdir -p debian/elpa-ess/usr/share/ess
#	cp -a etc debian/elpa-ess/usr/share/ess/
	(cd debian/elpa-ess/usr/share/emacs/site-lisp/elpa-src/ess-*/etc/ && rm -f BACKBUGS.BAT ess-sas-sh-command backbug*)

	touch install-stamp

# Build architecture-independent files here.
binary-indep: build install
	dh_testdir
	dh_testroot
	dh_installdocs
	dh_installemacsen
	dh_installinfo $$(find doc -type f -name "*.info*")
	dh_installchangelogs 
	rm -fv debian/ess/usr/share/doc/elpa-ess/ChangeLog
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

# Build architecture-dependent files here.
binary-arch: build install

source diff:
	@echo >&2 'source and diff are obsolete - use dpkg-source -b'; false

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install

## ess 18.10-1

=== debian/changelog ===
ess (18.10-1-2xenial0) xenial; urgency=medium

  * Compilation for Ubuntu 16.04.4 LTS
  * debian/control, revert to a version of emacsen-common that is
    available

 -- Michael Rutter <marutter@gmail.com>  Fri, 26 Oct 2018 01:48:36 +0000

ess (18.10-1-2) unstable; urgency=medium

  * debian/rules: No longer modify ess-site.el

 -- Dirk Eddelbuettel <edd@debian.org>  Wed, 24 Oct 2018 10:05:16 -0500

ess (18.10-1-1) unstable; urgency=medium

  * New upstream version released today

 -- Dirk Eddelbuettel <edd@debian.org>  Tue, 23 Oct 2018 19:59:57 -0500
